#!/usr/bin/env python
# Copyright (c) 2010  Adam Sloboda

# bugs:  does not repeat volume event like /dev/input/event1

import socket

import alsaaudio
mixer = alsaaudio.Mixer('PCM')

# acpid
sock = socket.socket(socket.AF_UNIX)
sock.connect('/var/run/acpid.socket')
acpi = sock.makefile()

# OSD
def update(cmd):
    sock = socket.socket()
    sock.connect(('localhost', 12321))
    sock.send(cmd)
    sock.close()

# events
def handler(event):
    #print event
    if event.startswith('video/brightness'):
        level = get_brightness()
        level = 100 * float(level) / max_brightness
        update('brightness %f' % level)

    elif event == 'button/volumeup':
        l,r = mixer.getvolume()
        l = min(l+3,100)
        mixer.setvolume(l)
        update('volume %d' % l)
    elif event == 'button/volumedown':
        l,r = mixer.getvolume()
        l = max(l-6,0)
        mixer.setvolume(l)
        update('volume %d' % l)
    #else:
    #    print 'received signal:', event

f = open('/sys/devices/virtual/backlight/acpi_video0/max_brightness')
max_brightness = float(f.read())
f.close()

def get_brightness():
    f = open('/sys/devices/virtual/backlight/acpi_video0/brightness')
    brightness = float(f.read())
    f.close()
    return brightness

while True:
    handler(acpi.readline().split()[0])
